import sqlite3
from db.helpers import *

class Mydb:
    def __init__(self):
        self.conn = sqlite3.connect('test.db', check_same_thread=False)
        self.cur = self.conn.cursor()
        
    def insert_ca(self, public, private):
        query = ''' INSERT INTO CA (date, public, private) VALUES (?, ?, ?) '''
        data = (time_utc(), public, private)
        self.cur.execute(query, data)
        self.conn.commit()
        return True
        
    def select_ca(self, caId=1):
        query = ''' SELECT * FROM CA WHERE caId = ? '''
        data = (caId, )
        self.cur.execute(query, data)
        returned = self.cur.fetchone()
        
        if not returned:
            return None
            
        return returned
    
    def insert_user(self, username, key, description, signature):
        query = ''' INSERT INTO users (date, username, key, description, signature) VALUES (?, ?, ?, ?, ?) '''
        data = (time_utc(), username, key, description, signature)
        self.cur.execute(query, data)
        self.conn.commit()
        return True
        
    def insert_host(self, principals, key, description, signature):
        query = ''' INSERT INTO hosts (date, principals, key, description, signature) VALUES (?, ?, ?, ?, ?) '''
        data = (time_utc(), principals, key, description, signature)
        self.cur.execute(query, data)
        self.conn.commit()
        return True
        
    def select_hosts(self):
        query = ''' SELECT * FROM hosts '''
        data = ()
        self.cur.execute(query, data)
        returned = self.cur.fetchall()
        
        if not returned:
            return None
        
        return returned
        
    def select_users(self):
        query = ''' SELECT * FROM users '''
        data = ()
        self.cur.execute(query, data)
        returned = self.cur.fetchall()
        
        if not returned:
            return None
        
        return returned
    
    def __del__(self):
        self.conn.commit()
        self.conn.close()